Complexity:
Is Regression: Yes
Sprint Focus:
Subject: IE8 Users can't login to backend
Description

From what I understand IE8 is still (kind of) supported, right?

When a user logs in to the backend with IE8 they won't see anything but a white page caused by the following JS exception:
Webpage error details

User Agent: Mozilla/4.0 (compatible; MSIE 8.0; Windows NT 5.2; Trident/4.0; .NET CLR 1.1.4322)
Timestamp: Mon, 17 Mar 2014 11:47:38 UTC

Message: Expected identifier
Line: 3956
Char: 61
Code: 0
URI:
http://example.com/typo3temp/compressor/merged-0409cb80b420cef16c8b514e2b382dbb-940cefcae7e07458d2dc490c43c14753.1395047044.js

Message: 'TYPO3.state.ExtDirectProvider' is null or not an object
Line: 135
Char: 4
Code: 0
URI: http://example.com/typo3/backend.php

753.1395047044.js

Message: 'TYPO3.state.ExtDirectProvider' is null or not an object
Line: 135
Char: 4
Code: 0
URI: http://example.com/typo3/backend.php

The error occurs here
TYPO3.settings.ShortcutMenu.delete.ajaxUrl

delete is a reserved word in JavaScript and causes problems in IE8 (and lower) only.

Regression from #56356.

Also I used the following regexp to look for similar issues, but did not find any:
(?<=\.)(brake|case|catch|continue|debugger|default|delete|do|else|finally|for|function|if|in|instanceof|new|return|switch|this|thro
|try|typeof|var|void|while|with)(?!\w)

Related issues:
follows Core - Task # 56356: Protect core Ajax calls against CSRF Resolved 2014-02-26
http://forum.typo3.org/index.php/t/199084/
https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Reserved_Words


Associated revisions
Revision 45a91e62 - 2014-03-30 15:55 - Nicole Cordes

[BUGFIX] Enable backend login for Internet Explorer 8 users

Due to some mystical IE8 behavior the global TYPO3 object gets reset
if any "var" occurs in Javascript. It is not necessary if its called or
not but it seems IE8 creates a new object. This patch adds the global
initialization of the TYPO3 object by using window[] syntax.

Resolves: #56988
Releases: 6.2
Change-Id: I5ce246790d1e3a1e388f106d085c96dae4e4304e
Reviewed-on: https://review.typo3.org/28929
Reviewed-by: Alexander Opitz
Tested-by: Alexander Opitz
Reviewed-by: Markus Klein
Tested-by: Markus Klein

History
#1 - 2014-03-17 13:33 - Gerrit Code Review
- Status changed from New to Under Review

Patch set 1 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at https://review.typo3.org/28463

#2 - 2014-03-17 13:38 - Christian Zenker

seems that there is another issue once this is solved:
Webpage error details

User Agent: Mozilla/4.0 (compatible; MSIE 8.0; Windows NT 5.2; Trident/4.0; .NET CLR 1.1.4322)
Timestamp: Mon, 17 Mar 2014 12:35:31 UTC

Message: 'TYPO3.settings.ModuleMenu' is null or not an object
Line: 528
Char: 1
Code: 0
URI:
http://example.com/typo3temp/compressor/merged-566ed042fb17d3b12ffba15783e9555f-970fed07969008aa5e4d700e577dfcf6.1395059229.js

Message: 'TYPO3.state.ExtDirectProvider' is null or not an object
Line: 135
Char: 4
Code: 0
URI: http://example.com/typo3/backend.php
js

Message: 'TYPO3.state.ExtDirectProvider' is null or not an object
Line: 135
Char: 4
Code: 0
URI: http://example.com/typo3/backend.php

I did a little bit of debugging (IE8 and "debugging" - haha) and this one is really confusing. TYPO3.settings.ModuleMenu is set correctly in the HTML
https://review.typo3.org/28929
https://review.typo3.org/28463


Source Code, but it seems to get lost somewhere. It could be something like reported on stackoverflow but I don't have more time to look in that more
deeply atm. Sorry.

#3 - 2014-03-26 23:06 - Helmut Hummel
- Status changed from Under Review to Needs Feedback

The structure of the ajax urls has been improved.

Can you check if the problem persists for you?

#4 - 2014-03-27 09:02 - Christoph Lehmann

The problem persists in TYPO3 6.2 LTS.

#5 - 2014-03-27 09:38 - Alexander Opitz
- Status changed from Needs Feedback to New
- Priority changed from Should have to Must have
- Target version changed from 6.2.0 to next-patchlevel

#6 - 2014-03-27 09:38 - Alexander Opitz
- Is Regression changed from No to Yes

#7 - 2014-03-27 10:37 - Nicole Cordes
- Status changed from New to Accepted
- Assigned To set to Nicole Cordes

#8 - 2014-03-27 14:53 - Helmut Hummel

Christoph Lehmann wrote:

The problem persists in TYPO3 6.2 LTS.

Can you please post the exact error messages here?
TYPO3.settings.ModuleMenu dosen't exist any more in 6.2.0

Thanks!

#9 - 2014-03-27 15:18 - Christoph Lehmann

With and without the patched line i get the same errors:

Details zum Fehler auf der Webseite

Benutzer-Agent: Mozilla/4.0 (compatible; MSIE 8.0; Windows NT 5.1; Trident/4.0)
Zeitstempel: Thu, 27 Mar 2014 14:08:59 UTC

Meldung: 'TYPO3.settings.ajaxUrls' ist Null oder kein Objekt
http://stackoverflow.com/questions/7801246/very-weird-thing-in-ie8-defined-variable-is-recognized-as-undefined


Zeile: 521
Zeichen: 1
Code: 0
URI:
http://example.com/typo3temp/compressor/merged-c035b0be7e7bf6ac7a2bd02425f41cf0-d7a6c2c44e91fc9fecf20d0a848b2947.js?1395929217

Meldung: 'TYPO3.state.ExtDirectProvider' ist Null oder kein Objekt
Zeile: 134
Zeichen: 4
Code: 0
URI: http://example.com/typo3/backend.php

17

Meldung: 'TYPO3.state.ExtDirectProvider' ist Null oder kein Objekt
Zeile: 134
Zeichen: 4
Code: 0
URI: http://example.com/typo3/backend.php

i deleted typo3temp/Cache, in the install tool all files from the compressor folder and the browser cache. Did i miss something?

#10 - 2014-03-27 15:50 - Christian Zenker

I can confirm the error message from Christoph - I get exactly the same one (tested on saucelabs)

#11 - 2014-03-27 15:51 - Christian Zenker

[removed duplicate post]

#12 - 2014-03-28 12:49 - Gerrit Code Review
- Status changed from Accepted to Under Review

Patch set 1 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at https://review.typo3.org/28929

#13 - 2014-03-29 11:27 - Gerrit Code Review

Patch set 2 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at https://review.typo3.org/28929

#14 - 2014-03-30 16:30 - Nicole Cordes
- Status changed from Under Review to Resolved
- % Done changed from 0 to 100

Applied in changeset commit:45a91e62a1308a2c6b239b03f3deafd822781f90.
